CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  
VAR

  long parameterX  'to pass memory location to ASM 

  'long displayX[256]  'This is your screen memory
  byte display[1024]

  byte buffer[1024]


PUB Main | g


'Put some crap on the screen
repeat g from 0 to 511
  display[g] := %00011011

repeat g from 512 to 1023
  display[g] := %01010101

  
'Make sure memory location is long-aligned
parameterX := @display[0]

'Start cog 7 and pass the screen memory location into it.
coginit(7, @Loader, @parameterX)

waitcnt(40_000_000 + cnt)

repeat

  Convert(@image)
   
  bytemove(@display, @buffer, 1024)
   
  Convert(@image2)
   
  bytemove(@display, @buffer, 1024)

repeat


PUB Convert(image_addr) | x, y, loc, databyte


loc := $436

repeat y from 31 to 0

  repeat x from 0 to 31
    
    repeat 4

      databyte <<= 2

      databyte |= (byte[image_addr][loc++] >> 6)

    buffer[y << 5 + x] := databyte    
  



DAT

image

file "test3.bmp"

image2

file "test4.bmp"


DAT     org

Loader
        rdlong memstart, par                            'Get location of the beginning of screen memory

        or dira, cdataML                                'Set all ouput pins to OUT direction (=1)
        or dira, cclockML
        or dira, clatchML
        or dira, rclockML
        or dira, rdataML
        or dira, enableML

        mov outa, rclockML                              'Set row strobe to DISABLE (active low)
        or outa, enableML                               'Set DMD disable to ENABLE (active high) (omit this to control from SPIN)

StartPWM
        mov doublecount, #0
        mov pwmcount, #0                               'Reset PWM counter

DoFrame
        mov pointer, memstart                          'Set pointer to start of frames          
        mov row, #0                                    'Reset row

DoRow
        mov column, #32                                 'Number of columns (longs) per row

DoColumns
        mov todobits, #4                               'Number of pixels to do
                
        rdbyte datatemp, pointer                        'Load Datatemp with the current word of screen data
        ror datatemp, #2                                'This ensures we get all the bit efficiently
        
DoLongLoop                                              'Shift out 32 bits (16 pixels) of data
        rol datatemp, #2                                'Rotate Datatemp two bits (one pixel) to the left

        mov colormask, datatemp                         'Make a copy of Datatemp
        and colormask, msb2
        shr colormask, #6                               'Shift 6 to remove everything but the top 2 MSB's

        cmp pwmcount, colormask wc                      'If current PWM count (0-2) is less than the color value (1-3), display that color

        muxc outa, cdataML                              'Assert serial output bit

        muxz outa, cclockML                             'Pulse dot clock
        muxnz outa, cclockML

        djnz todobits, #DoLongLoop                      'Repeat until we've done all 32 bits
        
        add pointer, #1                                 'Increment memory pointer (4 bytes per chunk since it's long-aligned)
        djnz column, #DoColumns                         'Keep going until out of columns
 
RowEnd
        cmp zilch, #0 wz                                'Latch the data onto the registers
        muxz outa, clatchML
        muxnz outa, clatchML     

        cmp row, #0 wz                                  'Check if we're on row 0... (first row)
        muxz outa, rdataML                             'If on row 0, z = 1, else z = 0

        cmp zilch, #0 wz
        muxz outa, rclockML
        muxnz outa, rclockML 

        MOV WaitCount, CNT
        ADD WaitCount, Rate
        waitcnt WaitCount, Rate

        add row, #1

        cmp row, #32 wc                                 'Did we reach the last row?
        if_c jmp #DoRow                                 'If not, do next row 

        add pwmCount, #1                                'Increment PWM count
        cmp pwmCount, #4 wc                             'Did it hit 3 yet?
        if_c jmp #DoFrame                               'If not, do next color level

        add doubleCount, #1                             'Increase double counter for level 3. This makes the brightest color (level 3) more distinct than level 2.
        cmp doubleCount, #3 wz
        if_z jmp#StartPWM                               'After doubleCount times out, start over

        mov pwmCount, #2                                'Else, reset pwmCount to #2 so it will draw that frame again

        jmp #DoFrame                                    'Draw Color 2 frame again





'Set pin #'s                 Prop Pin #         DMD SIGNAL:   DMD PIN #:        Remember to also tie the DMD and Propeller's ground signals together!
cdataML       long      1 <<    5                  'Serial Data (pin 11)                  
cclockML      long      1 <<    4                  'Dot Clock   (pin 9)
clatchML      long      1 <<    3                  'Column Latch (pin 7)
rclockML      long      1 <<    2                  'Row Clock    (pin 5)
rdataML       long      1 <<    1                  'Row Data     (pin 3)
enableML      long      1 <<    0                   'DMD Enable   (pin 1)



Rate          long     2000                    'Amount of delay per row. Lower = dimmer with less flickering                   Higher = brighter with more flickering
zilch         long     0
msb2          long     %00000000_00000000_00000000_11000000


'Variables
WaitCount     long      0
    
row           long      0                       'Which row we are on (0-31)
column        long      0                       'Which column we are on (0-7)
datatemp      byte      0                       'Used for temp data storage and bitwise operations
memstart      long      0                       'Start of screen memory
pointer       long      0                       'Current location in screen memory
pwmcount      long      0                       'Which cycle of PWM we are on
colormask     byte      0                       'Used to chop up Datatemp into grayscale levels
doublecount   long      0                       'Counter to run "Frame 3" of the PWM twice to make it more distinct

todobits      long      0                       'Counts how many bits need to be shifted out of current long data position